<?php

namespace Teknisa\CRM\Factory;

use Doctrine\ORM\EntityManager;

class crm00002006FilaContatoFactory {
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    public function inserirTarefa($params, $entityManager = null) {
        $sql = "INSERT INTO FILACONTATO (
                    DSFILACONTATO,      DTPLANFILACONTA,    CDOPERREAL,
                    NRORG,              DTINCLUSAO,         NRORGINCLUSAO,
                    CDOPERINCLUSAO,     NRPARCNEGOCIO,      IDORIGFILACONTA,
                    IDATIVO,            NRCONTATO,          NRSEQCONTATO,
                    NRPRIORFILACONT,    NRSEQFILACONTA,     NRSEQCAMPANHA, 
                    NRSEQINTERLOCUTOR,  DSEMAILTAREFA,      DSTELEFONETAREFA,
                    NRSEQCLASSIFICATAREFA, CRM_NRORGTRAB)
                VALUES (
                    :DSFILACONTATO,     :DTPLANFILACONTA,   :CDOPERREAL,
                    :NRORG,             SYSDATE,            :NRORG,
                    :CDOPERINCLUSAO,    :NRPARCNEGOCIO,     'M',
                    'S',                :NRCONTATO,         :NRSEQCONTATO,
                    :NRPRIORFILACONT,   :NRSEQFILACONTA,    :NRSEQCAMPANHA,
                    :NRSEQINTERLOCUTOR, :DSEMAILTAREFA,     :DSTELEFONETAREFA,
                    :NRSEQCLASSIFICATAREFA, :CRM_NRORGTRAB)";
        if(!empty($entityManager)){
            $this->connection = $entityManager->getConnection();
        }        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function insertLeadEvolNextTask($paramsSetTaskEndDate){

        $insert = "INSERT INTO FILACONTATO (DSFILACONTATO,DTPLANFILACONTA,CDOPERREAL,NRSEQFILACONTA,NRORG,DTINCLUSAO,NRORGINCLUSAO,
                               CDOPERINCLUSAO,NRPARCNEGOCIO,IDORIGFILACONTA,IDATIVO,NRCONTATO,NRSEQCONTATO)
                    VALUES (:DSFILACONTATO,
                            :DTPLANFILACONTA,
                            :CDOPERREAL,
                            :NRSEQFILACONTA,
                            :NRORG,
                             SYSDATE,
                            :NRORGINCLUSAO,
                            :CDOPERINCLUSAO,
                            :NRPARCNEGOCIO,
                             'M',
                             'S',
                            :NRCONTATO,
                            :NRSEQCONTATO)";
                 
        try{
            $std = $this->connection->prepare($insert);
            $std->execute($paramsSetTaskEndDate);
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function requestForSetTaskEndDate($paramsSetTaskEndDate){
        $update = "UPDATE FILACONTATO 
                   SET DTREALFILACONTA = SYSDATE
                   WHERE NRSEQFILACONTA = :NRSEQFILACONTA
                   AND NRORG = :NRORG";
        
        try{
            $std = $this->connection->prepare($update);
            $std->execute($paramsSetTaskEndDate);
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function requestForDeactivateOpportunityTask($paramsDeactivateTask){
        
        $update = "UPDATE FILACONTATO 
                   SET IDATIVO = 'N'
                   WHERE NRSEQFILACONTA = :NRSEQFILACONTA";
        
        try{
            $std = $this->connection->prepare($update);
            $std->execute($paramsDeactivateTask);
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function updateEvol($params){
        $update = "UPDATE EVOLCONT 
                   SET NRSEQFILACONTA = :NRSEQFILACONTA
                   WHERE NRSEQEVOLCONT = :NRSEQEVOLCONT
                   AND NRORG = :NRORG";
        
        try{
            $std = $this->connection->prepare($update);
            $std->execute($params);
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
}