<?php
namespace Teknisa\CRM\Util;

class CSVUtils
{
	const fileRead = 'r';

	private $csvFile;
	private $csvDelimitador;
	private $csvCerca;

	public function __construct($csvFilePath, $delimitador, $cerca, $read = self::fileRead) 
	{		
        $this->csvFile = fopen($csvFilePath, $read);        
        $this->csvDelimitador = $delimitador;
        $this->csvCerca = $cerca;        
	}

	public function buildDataIntoJson()
	{
		return $this->getData();
	}

	private function getData() 
	{
		$headers = $this->getHeaders();
		$data    = array();
        
		if ($this->csvFile) {
 
		    // Enquanto nao terminar o arquivo
		    while (!feof($this->csvFile)) {
		 
		        // Ler uma linha do arquivo
		        $line = fgetcsv($this->csvFile, 0, $this->csvDelimitador);		        
		        if (!$line) {
		            continue;
		        }
		 		
		        // Montar data com valores indexados pelo cabecalho
		        $linhaData = array_combine($headers, $line);

		        if (!$linhaData) {
		        	throw new \Exception("Quantidade de colunas diferente da quantidade de colunas do cabeçalho.");
		        } else {
		        	$data[] = $linhaData;
		    	}		        
		    }

		    fclose($this->csvFile);

		    return $data;
		}		
	}

	private function getHeaders() 
	{		
    	$headers = array();    			
    	foreach (fgetcsv($this->csvFile, 0, $this->csvDelimitador, $this->csvCerca) as $value) {    		
    		$headers[] = strtoupper(\Teknisa\CRM\Util\Util::removeCaracteresInvalidos($value));
    	}

		return $headers;
	}

}