function crm00060000_Campanhas_de_Maling(CRM_Utilities, templateManager) {
    
    /**
     * Define o filtro da widget principal da tela de
     * campanha de mailing pelo operador logado.
     * 
     * @param {object} widget widget principal 'WDGT_CAMPANHA_MAILING'
    */
    this.setCampaignWidgetDefaultFilterByLoggedOperator = function(widget){
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        var cdoperadorFilterIndex = CRM_Utilities.getObjectPositionInArrayByName(widget.dataSourceFilter, "CDOPERADOR");
        
        //widget.dataSourceFilter[cdoperadorFilterIndex].value = loggedOperatorInfos.CDOPERADOR;
        
        //this.setValueFilterInFilterPopUpCurrentDataSet('NMOPERADOR', loggedOperatorInfos.NMOPERADOR);
        //this.setValueFilterInFilterPopUpCurrentDataSet('CDOPERADOR', loggedOperatorInfos.CDOPERADOR);
        
    };
    
    /**
     * Seta valores no dataset do popup do filtro.
     * 
     * @param {string} fieldName nome do campo referência.
     * 
     * @param {string|Object} value valor a ser setado.
    */
    this.setValueFilterInFilterPopUpCurrentDataSet = function(fieldName, value){
        
        var campaignWidget = templateManager.container.getWidget('WDGT_CAMPANHA_MAILING');
        var filterPopup = campaignWidget.__filterPopup;
        
        filterPopup.currentRow[fieldName] = value;
        
    };
    
    /**
     * Define as regras da tela de campanhas de mailing
     * de acordo com a revenda do operador logado.
     * 
     * @param {object} widget widget principal da tela de
     * campanha de mailing ('WDGT_CAMPANHA_MAILING').
    */
    this.setResaleRules = function(widget) {
        
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        if(loggedOperatorInfos.IDTPOPERADOR === 'R' && Boolean(loggedOperatorInfos.NRREVENDA)){
            
            var restrictObjects = [];
            
            restrictObjects.push(widget);
            restrictObjects.push(widget.getField("NMOPERADOR"));
            
            CRM_Utilities.setResaleRulesInRestrictObjectsByLoggedOperatorResale(restrictObjects);
            
        }
    };
    
}

Configuration(function (ContextRegister) {
    ContextRegister.register("crm00060000_Campanhas_de_Maling", crm00060000_Campanhas_de_Maling);
});
